#include "NewsFleX.h"

FD_NewsFleX *fdui;

pthread_t *edit_thread;


static volatile int running = 0; 
static volatile int stop = 0;    
int new_program_flag;


void *edit_routine()
{
char edit_command[TEMP_SIZE];
FILE *exec_fd;

if(debug_flag)
	{
	fprintf(stdout, "edit_routine(): arg none\n");
	}

while(1)
	{
	if(new_program_flag)
		{
		if(debug_flag)
			{
			printf("start edit_process\n");
			}

		new_program_flag = 0;
//		while(1)
//			{		
//			running = 1;

//			if(stop)
//				{
//				break;
//				}

			/* edit temp file */
			/*xterm -e joe $posting*/
/*color_xterm -geometry 77x28+1026+1712 -sb -sl 500 -j -ls -fn 10x20 &*/

			/* replace '$posting' with path filename of tempfile */
			replace(\
			alt_editor_command, "$posting", edit_filename, edit_command);

			if(debug_flag)
				{
				printf("edit_routine(): edit_command=%s\n", edit_command);
				}

			//system(edit_command);

			/* start external editor in xterm or rxvt */

			exec_fd = popen(edit_command, "r");
			if(! exec_fd)
				{
//				fl_show_alert("Cannot execute", edit_command, "", 0);

//				/* allow user to press buttons again */
//				fl_activate_all_forms();

//				return(0);
				
				}
			pclose(exec_fd);

			/* here we closed the external editor */

//			} /* end while ! stop */
//		running = 0;
		
		external_editor_ready_flag = 1;
//		break;

		if(debug_flag)
			{
			printf("exit edit_process()\n");
			}

		} /* end if new_program_flag */

	/* take it easy on processor cycles */
	usleep(10000);
	} /* end if program has changed */

} /* end function edit_routine */


int edit_init()
{
if(debug_flag)
	{
	printf("edit_init(): arg none\n");
	}

pthread_create( (pthread_t *)&edit_thread, NULL , &edit_routine, NULL);

return 1;
} /* end function edit_init */


void edit_start()
{
if(debug_flag)
	{
	printf("edit_start() arg none\n");
	}

new_program_flag = 1;

} /* end function edit_start */


void edit_stop()
{
if(debug_flag)
	{
	printf("edit_stop(): arg none\n");
	}

stop = 1;

if(running)
	{
	stop = 1;
	while(running)
		{
		usleep(100000);
		}
	} /* end if running */

stop = 0;

} /* end function edit_stop */


