/* 
NewsFleX offline NNTP news reader
NewsFleX is registered Copyright (C) 1997-2005 <Jan Panteltje>
email: panteltje@yahoo.com

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "NewsFleX.h"

extern FD_NewsFleX *fdui;


void secret_input_form_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;
char temp[1024];

/* get the password */
ptr = (char *)fl_get_input(fdui -> secret_input_form_input);
if(! ptr) return;

/*
let idle_cb remove the form and set this flag to zero again, else
we go in a recursive loop.
*/
hide_secret_input_form_flag = 1;

/* a clear input field would also clear ptr!! */
strcpy(temp, ptr);

show_filter_form(temp);
} /* end function secret_input_form_input_cb */


void secret_input_form_cancel_button_cb(FL_OBJECT *ob, long data)
{
fl_set_input(fdui -> secret_input_form_input, "");

hide_secret_input_form_flag = 1;
} /* end function secret_input_form_cancel_button_cb */


void secret_input_form_ok_button_cb(FL_OBJECT *ob, long data)
{
char *ptr;
char temp[1024];

/* get the password */
ptr = (char *)fl_get_input(fdui -> secret_input_form_input);
if(! ptr) return;

/* a clear input field would also clear ptr!! */
strcpy(temp, ptr);

hide_secret_input_form_flag = 1;

show_filter_form(temp);
} /* end function secret_input_form_ok_button_cb */


void secret_input_form_clear_button_cb(FL_OBJECT *ob, long data)
{

fl_set_input(fdui -> secret_input_form_input, "");

} /* end function secret_input_form_clear_button_cb */


